﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using samplebrowser.Models;

namespace ejGridASPCore.Controllers
{
    public partial class HomeController : Controller
    {
        //private NORTHWNDContext _context;
        public IActionResult Index()
        {
            //IEnumerable data = _context.Employees.ToList();
            if (order.Count() == 0)
                BindDataSource();
            ViewBag.parent = emp;
            return View();
        }
        public static List<Orders> order = new List<Orders>();
        public static List<Employees> emp = new List<Employees>();
        public static List<Customers> cus = new List<Customers>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", 1, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, "ANATR", 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", 3, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", 4, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", 5, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));

                order.Add(new Orders(code + 3, "ANTON", 6, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", 7, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", 8, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
            cus.Add(new Customers("ALFKI", "MS", "MR", "California"));
            cus.Add(new Customers("ANATR", "MS", "MR", "California"));
            cus.Add(new Customers("ANTON", "MS", "MR", "California"));
            cus.Add(new Customers("BLONP", "MS", "MR", "California"));
            cus.Add(new Customers("BOLID", "MS", "MR", "California"));

            emp.Add(new Employees(1, "Nancy", "Davolio", new DateTime(1948, 12, 08), "USA"));
            emp.Add(new Employees(2, "Andrew", "Fuller", new DateTime(1952, 02, 19), "USA"));
            emp.Add(new Employees(3, "Janet", "Leverling", new DateTime(1963, 08, 30), "USA"));
            emp.Add(new Employees(4, "Margaret", "Peacock", new DateTime(1937, 09, 19), "USA"));
            emp.Add(new Employees(5, "Steven", "Buchanan", new DateTime(1955, 03, 04), "UK"));
            emp.Add(new Employees(6, "Michael", "Suyama", new DateTime(1963, 07, 02), "UK"));
            emp.Add(new Employees(7, "Robert", "King", new DateTime(1960, 05, 29), "UK"));
            emp.Add(new Employees(8, "Laura", "Callahan", new DateTime(1958, 01, 09), "USA"));
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long ID, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string AdresseTyp)
            {
                this.ID = ID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.AdresseTyp = AdresseTyp;
            }
            
            public long ID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string AdresseTyp { get; set; }
        }
        public partial class Customers
        {
            public string CustomerID
            {
                get; set;
            }
            public string CompanyName
            {
                get; set;
            }
            public string ContactTitle { get; set; }
            public string City { get; set; }
            public Customers() { }

            public Customers(string CID, string Cname, string CTitle, string city) {
                this.CustomerID = CID;
                this.CompanyName = Cname;
                this.ContactTitle = CTitle;
                this.City = city;
            }
        }
        public class Employees
        {
            public Employees()
            {

            }
            public Employees(int EmployeeId, string FirstName, string LastName, DateTime BirthDate, string Country)
            {

                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
                this.LastName = LastName;
                this.BirthDate = BirthDate;
                this.Country = Country;
            }
            public int EmployeeID { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public DateTime BirthDate { get; set; }
            public string Country { get; set; }
        }
        public ActionResult AdrTypDataAll([FromBody]DataManager dm)
        {
            IEnumerable DataSource = order;
            DataOperations ds = new DataOperations();
            int count = DataSource.Cast<Orders>().ToList().Count();//count
            if (dm.Skip != null)
                DataSource = ds.PerformSkip(DataSource, dm.Skip);
            if (dm.Take != null)
                DataSource = ds.PerformTake(DataSource, dm.Take);
            return Json(new { result = DataSource, count=count });
        }
        public ActionResult GetData()
        {
            IEnumerable DataSource = order;
            //  order[0].CustomerID = "VINET";

            var id = "YYYYY";
            order = order.Where(o => o.CustomerID == id).ToList();

            return Json("success");
        }
        public ActionResult CellEditUpdate([FromBody]CRUDModel<Orders> value)
        {
            var ord = value.Value;
            Orders val = order.Where(or => or.ID == ord.ID).FirstOrDefault();
            val.ID = ord.ID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.Freight = ord.Freight;
            val.OrderDate = ord.OrderDate;
            val.AdresseTyp = ord.AdresseTyp;

            return Json(value.Value);
        }
        public ActionResult CellEditInsert([FromBody]CRUDModel<Orders> value)
        {
            value.Value.ID = order.LastOrDefault().ID + 1;
            order.Insert(0, value.Value);
            return Json(value.Value);
        }
        public ActionResult CellEditDelete([FromBody]CRUDModel<Orders> value)
        {
            order.Remove(order.Where(or => or.ID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }
        public ActionResult CellEditUpdate1([FromBody]CRUDModel<Customers> value)
        {
            var ord = value.Value;
            Customers val = cus.Where(or => or.CustomerID == ord.CustomerID).FirstOrDefault();
            val.CustomerID = ord.CustomerID;
            val.CompanyName = ord.CompanyName;
            val.ContactTitle = ord.ContactTitle;

            return Json(value.Value);
        }
        //public ActionResult CellEditInsert1([FromBody]CRUDModel<Customers> value)
        //{
        //    value.Value.CustomerID = cus.LastOrDefault()
        //    order.Insert(0, value.Value);
        //    return Json(value.Value);
        //}
        public ActionResult CellEditDelete1([FromBody]CRUDModel<Customers> value)
        {
            cus.Remove(cus.Where(or => or.CustomerID == value.Key).FirstOrDefault());
            return Json(value);
        }
    }
}
